<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { ref } from 'vue';
import { storeToRefs } from 'pinia';
import Modal from '@/components/general/Modal.vue';
import { useFreeformStore } from '@/stores/freeform';
import EditLineModal from '@/components/freeform/EditLineModal.vue';

const store = useFreeformStore();
const { getFullUsable, getDeletable, getStyle, lineId, contextMenuPosition, lineArray:getLineArray } = storeToRefs(store);
const lineIndex = getLineArray.value?.findIndex((x: any) => x.id === lineId.value);

const isDeleteLineModalOpen = ref(false);
const showDeleteLineModal = (value: boolean) => {
    isDeleteLineModalOpen.value = value;
    if (!value) {
        contextMenuPosition.value = null;
        //lineIndex.value = -1;
    }
};

const isContextMenuOpen = ref(true);

const closeContextMenu = () => {
    isContextMenuOpen.value = false;
    contextMenuPosition.value = { display: 'hide' };
}

const submitDeleteLine = () => {
    store.deleteLine({ lineIndex: lineIndex });
    showDeleteLineModal(false);
    contextMenuPosition.value = null;
};

const deleteLine = () => {
    closeContextMenu();
    showDeleteLineModal(true);
};

const editLineText = () => {
    closeContextMenu();
    showLineTextModal(true);
}

const isLineTextModalOpen = ref(false);
const showLineTextModal = (value: boolean) => {
    isLineTextModalOpen.value = value;
    if (!value)
        contextMenuPosition.value = null;
}


</script>
<template>
    <div :class="['box-border transition duration-100 ease-in-out rounded-lg bg-white text-gray-500 shadow-md absolute z-[2000] p-2', getStyle?.font ? getStyle.font : '']"
        :style="contextMenuPosition" v-if="getFullUsable || isContextMenuOpen">
        <div class="flex flex-col gap-2">
            <button class="flex flex-row gap-2 hover:bg-gray-100 px-2 py-1 rounded-md" @click="deleteLine" v-if="getDeletable">
                <i class="ri-delete-bin-line text-red-700"></i>
                <span>{{ $t('contentPage.deleteLabel') }}</span>
            </button>
            <button class="flex flex-row gap-2 hover:bg-gray-100 px-2 py-1 rounded-md" @click="editLineText" v-if="getStyle.lineText">
                <i class="ri-pencil-line text-blue-700"></i>
                <span>{{ $t('contentPage.editLabel') }}</span>
            </button>
        </div>
    </div>
    <Modal v-if="isDeleteLineModalOpen" :text="$t('contentPage.deleteLine')" @cancel="showDeleteLineModal(false)"
        :labelCancel="$t('general.buttons.cancel')" @submit="submitDeleteLine" :labelSubmit="$t('general.buttons.ok')"
        :font="getStyle?.font ? getStyle.font : ''"/>
    <EditLineModal v-if="isLineTextModalOpen" @close="showLineTextModal(false)" />
</template>